#define _POSIX_C_SOURCE (199309L)

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

#define REPETITIONS (20U)

typedef struct {
    char name[32U];
    float value;
} sensor_value_t;

static void delay(void)
{
    struct timespec waiting_time = { 0, rand() };
    nanosleep( &waiting_time, NULL);
}

static void sensor_runner(sensor_value_t *entry, char *name, float value)
{
    printf("Run %s sensor\n", name);
    snprintf(entry->name, sizeof(entry->name), "%s", name);
    delay();
    entry->value = value;
}

static void temperature_sensor(sensor_value_t *entry)
{
    sensor_runner(entry, "Temperature", 23.4567F);
}

static void humditity_sensor(sensor_value_t *entry)
{
    sensor_runner(entry, "Humidity", 62.12F);
}

static void db_writer(sensor_value_t *entry)
{
    printf("Read sensor value:" \
           "\tSensor:\t%s" \
           "\tValue:\t%3.4f\n",
           entry->name, entry->value);
    delay();
}

int main(void)
{
    srand(time(NULL));
    sensor_value_t database_entry;

    for (size_t i = 0; i < REPETITIONS; ++i)
    {
        temperature_sensor(&database_entry);
        db_writer(&database_entry);
        humditity_sensor(&database_entry);
        db_writer(&database_entry);
    }

    return EXIT_SUCCESS;
}
